# Account

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**name** | **str** | Name of the account. Account names must be unique within an SDKMS instance. | 
**acct_id** | **str** | Account ID uniquely identifying this account. | 
**description** | **str** | Description of this account. | [optional] 
**organization** | **str** | Organization (e.g. company name) that owns this account | [optional] 
**country** | **str** | Main country associated with this account | [optional] 
**phone** | **str** | Contact phone number associated with this account | [optional] 
**notification_pref** | [**NotificationPref**](NotificationPref.md) |  | [optional] 
**auth_config** | [**AuthConfig**](AuthConfig.md) |  | [optional] 
**subscription** | [**SubscriptionType**](SubscriptionType.md) |  | 
**state** | [**AccountState**](AccountState.md) |  | 
**auth_type** | [**AuthType**](AuthType.md) |  | 
**logging_configs** | [**dict(str, LoggingConfig)**](LoggingConfig.md) | Map from UUIDs to LoggingConfig objects | [optional] 
**enabled** | **bool** | Whether this account is enabled. This may only be changed by sysadmins. | [optional] 
**created_at** | **str** | When this account was created. | [optional] 
**initial_purchase_at** | **str** | When this accout was upgraded a paid subscription. | [optional] 
**pending_subscription_change_request** | [**SubscriptionChangeRequest**](SubscriptionChangeRequest.md) |  | [optional] 
**custom_metadata** | **dict(str, str)** | Sysadmin-defined metadata for this account. Stored as key-value pairs. This field is only visible to sysadmin users.  | [optional] 

[[Back to Model list]](../README.md#documentation-for-models) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to README]](../README.md)


