# sdkms/v1.EncryptionAndDecryptionApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**batch_decrypt**](EncryptionAndDecryptionApi.md#batch_decrypt) | **POST** /crypto/v1/keys/batch/decrypt | Batch decrypt with one or more keys
[**batch_encrypt**](EncryptionAndDecryptionApi.md#batch_encrypt) | **POST** /crypto/v1/keys/batch/encrypt | Batch encrypt with one or more keys
[**decrypt**](EncryptionAndDecryptionApi.md#decrypt) | **POST** /crypto/v1/keys/{key-id}/decrypt | Decrypt data
[**decrypt_ex**](EncryptionAndDecryptionApi.md#decrypt_ex) | **POST** /crypto/v1/decrypt | Decrypt data
[**decrypt_final**](EncryptionAndDecryptionApi.md#decrypt_final) | **POST** /crypto/v1/keys/{key-id}/decrypt/final | Conclude multi-part decryption
[**decrypt_final_ex**](EncryptionAndDecryptionApi.md#decrypt_final_ex) | **POST** /crypto/v1/decrypt/final | Conclude multi-part decryption
[**decrypt_init**](EncryptionAndDecryptionApi.md#decrypt_init) | **POST** /crypto/v1/keys/{key-id}/decrypt/init | Begin multi-part decryption
[**decrypt_init_ex**](EncryptionAndDecryptionApi.md#decrypt_init_ex) | **POST** /crypto/v1/decrypt/init | Begin multi-part decryption
[**decrypt_update**](EncryptionAndDecryptionApi.md#decrypt_update) | **POST** /crypto/v1/keys/{key-id}/decrypt/update | Continue multi-part decryption
[**decrypt_update_ex**](EncryptionAndDecryptionApi.md#decrypt_update_ex) | **POST** /crypto/v1/decrypt/update | Continue multi-part decryption
[**encrypt**](EncryptionAndDecryptionApi.md#encrypt) | **POST** /crypto/v1/keys/{key-id}/encrypt | Encrypt data
[**encrypt_ex**](EncryptionAndDecryptionApi.md#encrypt_ex) | **POST** /crypto/v1/encrypt | Encrypt data
[**encrypt_final**](EncryptionAndDecryptionApi.md#encrypt_final) | **POST** /crypto/v1/keys/{key-id}/encrypt/final | Conclude multi-part encryption
[**encrypt_final_ex**](EncryptionAndDecryptionApi.md#encrypt_final_ex) | **POST** /crypto/v1/encrypt/final | Conclude multi-part encryption
[**encrypt_init**](EncryptionAndDecryptionApi.md#encrypt_init) | **POST** /crypto/v1/keys/{key-id}/encrypt/init | Begin multi-part encryption
[**encrypt_init_ex**](EncryptionAndDecryptionApi.md#encrypt_init_ex) | **POST** /crypto/v1/encrypt/init | Begin multi-part encryption
[**encrypt_update**](EncryptionAndDecryptionApi.md#encrypt_update) | **POST** /crypto/v1/keys/{key-id}/encrypt/update | Continue multi-part encryption
[**encrypt_update_ex**](EncryptionAndDecryptionApi.md#encrypt_update_ex) | **POST** /crypto/v1/encrypt/update | Continue multi-part encryption


# **batch_decrypt**
> BatchDecryptResponse batch_decrypt(body)

Batch decrypt with one or more keys

The data to be decrypted and the key ids to be used are provided in the request body. The decrypted plain text is returned in the response body. The ordering of the body matches the ordering of the request. An individual status code is returned for each batch item. Maximum size of the entire batch request is 512 KB. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.BatchDecryptRequest() # BatchDecryptRequest | Batch decryption request

try: 
    # Batch decrypt with one or more keys
    api_response = api_instance.batch_decrypt(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->batch_decrypt: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BatchDecryptRequest**](BatchDecryptRequest.md)| Batch decryption request | 

### Return type

[**BatchDecryptResponse**](BatchDecryptResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **batch_encrypt**
> BatchEncryptResponse batch_encrypt(body)

Batch encrypt with one or more keys

The data to be encrypted and the key ids to be used are provided in the request body. The encrypted cipher text is returned in the response body. The ordering of the body matches the ordering of the request. An individual status code is returned for each batch item. Maximum size of the entire batch request is 512 KB. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.BatchEncryptRequest() # BatchEncryptRequest | Batch Encryption request

try: 
    # Batch encrypt with one or more keys
    api_response = api_instance.batch_encrypt(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->batch_encrypt: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**BatchEncryptRequest**](BatchEncryptRequest.md)| Batch Encryption request | 

### Return type

[**BatchEncryptResponse**](BatchEncryptResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **decrypt**
> DecryptResponse decrypt(key_id, body)

Decrypt data

Decrypt data using a symmetric or asymmetric key. For symmetric ciphers, mode (specifying the block cipher mode) is a required field. <br> For GCM and CCM modes, tag_len is a required field. <br> iv is required for symmetric ciphers and unused for asymmetric ciphers. It must contain the initialization value used when the object was encrypted. <br> Objects of type opaque, EC, or HMAC may not be used for encryption or decryption. <br> 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
key_id = 'key_id_example' # str | kid of security object
body = sdkms/v1.DecryptRequest() # DecryptRequest | Decryption request

try: 
    # Decrypt data
    api_response = api_instance.decrypt(key_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->decrypt: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **str**| kid of security object | 
 **body** | [**DecryptRequest**](DecryptRequest.md)| Decryption request | 

### Return type

[**DecryptResponse**](DecryptResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **decrypt_ex**
> DecryptResponse decrypt_ex(body)

Decrypt data

Decrypt data using a symmetric or asymmetric key. For symmetric ciphers, mode (specifying the block cipher mode) is a required field. <br> For GCM and CCM modes, tag_len is a required field. <br> iv is required for symmetric ciphers and unused for asymmetric ciphers. It must contain the initialization value used when the object was encrypted. <br> Objects of type opaque, EC, or HMAC may not be used for encryption or decryption. <br> 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.DecryptRequestEx() # DecryptRequestEx | Decryption request

try: 
    # Decrypt data
    api_response = api_instance.decrypt_ex(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->decrypt_ex: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**DecryptRequestEx**](DecryptRequestEx.md)| Decryption request | 

### Return type

[**DecryptResponse**](DecryptResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **decrypt_final**
> DecryptFinalResponse decrypt_final(key_id, body)

Conclude multi-part decryption

Conclude a multi-part decryption operation. See `decrypt/init` for details. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
key_id = 'key_id_example' # str | kid of security object
body = sdkms/v1.DecryptFinalRequest() # DecryptFinalRequest | Finish multi-part decryption

try: 
    # Conclude multi-part decryption
    api_response = api_instance.decrypt_final(key_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->decrypt_final: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **str**| kid of security object | 
 **body** | [**DecryptFinalRequest**](DecryptFinalRequest.md)| Finish multi-part decryption | 

### Return type

[**DecryptFinalResponse**](DecryptFinalResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **decrypt_final_ex**
> DecryptFinalResponse decrypt_final_ex(body)

Conclude multi-part decryption

Conclude a multi-part decryption operation. See `decrypt/init` for details. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.DecryptFinalRequestEx() # DecryptFinalRequestEx | Finish multi-part decryption

try: 
    # Conclude multi-part decryption
    api_response = api_instance.decrypt_final_ex(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->decrypt_final_ex: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**DecryptFinalRequestEx**](DecryptFinalRequestEx.md)| Finish multi-part decryption | 

### Return type

[**DecryptFinalResponse**](DecryptFinalResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **decrypt_init**
> DecryptInitResponse decrypt_init(key_id, body)

Begin multi-part decryption

This API is used when decrypting more data than the client wishes to submit in a single request. It supports only symmetric ciphers and only conventional (not AEAD) modes of operation. To perform multi-part decryption, the client makes one request to the `init` resource, zero or more requests to the `update` resource, followed by one request to the `final` resource. The response to init and update requests includes a `state` field. The `state` is an opaque data blob that must be supplied unmodified by the client with the subsequent request. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
key_id = 'key_id_example' # str | kid of security object
body = sdkms/v1.DecryptInitRequest() # DecryptInitRequest | Multi-part decryption initialization request

try: 
    # Begin multi-part decryption
    api_response = api_instance.decrypt_init(key_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->decrypt_init: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **str**| kid of security object | 
 **body** | [**DecryptInitRequest**](DecryptInitRequest.md)| Multi-part decryption initialization request | 

### Return type

[**DecryptInitResponse**](DecryptInitResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **decrypt_init_ex**
> DecryptInitResponse decrypt_init_ex(body)

Begin multi-part decryption

This API is used when decrypting more data than the client wishes to submit in a single request. It supports only symmetric ciphers and only conventional (not AEAD) modes of operation. To perform multi-part decryption, the client makes one request to the `init` resource, zero or more requests to the `update` resource, followed by one request to the `final` resource. The response to init and update requests includes a `state` field. The `state` is an opaque data blob that must be supplied unmodified by the client with the subsequent request. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.DecryptInitRequestEx() # DecryptInitRequestEx | Multi-part decryption initialization request

try: 
    # Begin multi-part decryption
    api_response = api_instance.decrypt_init_ex(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->decrypt_init_ex: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**DecryptInitRequestEx**](DecryptInitRequestEx.md)| Multi-part decryption initialization request | 

### Return type

[**DecryptInitResponse**](DecryptInitResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **decrypt_update**
> DecryptUpdateResponse decrypt_update(key_id, body)

Continue multi-part decryption

Continue a multi-part decryption operation. See `decrypt/init` for details. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
key_id = 'key_id_example' # str | kid of security object
body = sdkms/v1.DecryptUpdateRequest() # DecryptUpdateRequest | Multi-part decryption

try: 
    # Continue multi-part decryption
    api_response = api_instance.decrypt_update(key_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->decrypt_update: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **str**| kid of security object | 
 **body** | [**DecryptUpdateRequest**](DecryptUpdateRequest.md)| Multi-part decryption | 

### Return type

[**DecryptUpdateResponse**](DecryptUpdateResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **decrypt_update_ex**
> DecryptUpdateResponse decrypt_update_ex(body)

Continue multi-part decryption

Continue a multi-part decryption operation. See `decrypt/init` for details. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.DecryptUpdateRequestEx() # DecryptUpdateRequestEx | Multi-part decryption

try: 
    # Continue multi-part decryption
    api_response = api_instance.decrypt_update_ex(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->decrypt_update_ex: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**DecryptUpdateRequestEx**](DecryptUpdateRequestEx.md)| Multi-part decryption | 

### Return type

[**DecryptUpdateResponse**](DecryptUpdateResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **encrypt**
> EncryptResponse encrypt(key_id, body)

Encrypt data

Encrypt data using a symmetric or asymmetric key. <br> For symmetric ciphers, mode (specifying the block cipher mode) is a required field. <br> For GCM and CCM modes, tag_len is a required field. <br> iv is optional for symmetric ciphers and unused for asymmetric ciphers. If provided, it will be used as the cipher initialization value. Length of iv must match the initialization value size for the cipher and mode. If not provided, SDKMS will create a random iv of the correct length for the cipher and mode and return this value in the response. <br> Objects of type Opaque, EC, or HMAC may not be used for encryption or decryption. <br> 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
key_id = 'key_id_example' # str | kid of security object
body = sdkms/v1.EncryptRequest() # EncryptRequest | Encryption request

try: 
    # Encrypt data
    api_response = api_instance.encrypt(key_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->encrypt: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **str**| kid of security object | 
 **body** | [**EncryptRequest**](EncryptRequest.md)| Encryption request | 

### Return type

[**EncryptResponse**](EncryptResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **encrypt_ex**
> EncryptResponse encrypt_ex(body)

Encrypt data

Encrypt data using a symmetric or asymmetric key. <br> For symmetric ciphers, mode (specifying the block cipher mode) is a required field. <br> For GCM and CCM modes, tag_len is a required field. <br> iv is optional for symmetric ciphers and unused for asymmetric ciphers. If provided, it will be used as the cipher initialization value. Length of iv must match the initialization value size for the cipher and mode. If not provided, SDKMS will create a random iv of the correct length for the cipher and mode and return this value in the response. <br> Objects of type Opaque, EC, or HMAC may not be used for encryption or decryption. <br> 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.EncryptRequestEx() # EncryptRequestEx | Encryption request

try: 
    # Encrypt data
    api_response = api_instance.encrypt_ex(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->encrypt_ex: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**EncryptRequestEx**](EncryptRequestEx.md)| Encryption request | 

### Return type

[**EncryptResponse**](EncryptResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **encrypt_final**
> EncryptFinalResponse encrypt_final(key_id, body)

Conclude multi-part encryption

Conclude a multi-part encryption operation. See `encrypt/init` for details. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
key_id = 'key_id_example' # str | kid of security object
body = sdkms/v1.EncryptFinalRequest() # EncryptFinalRequest | Finish multi-part encryption

try: 
    # Conclude multi-part encryption
    api_response = api_instance.encrypt_final(key_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->encrypt_final: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **str**| kid of security object | 
 **body** | [**EncryptFinalRequest**](EncryptFinalRequest.md)| Finish multi-part encryption | 

### Return type

[**EncryptFinalResponse**](EncryptFinalResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **encrypt_final_ex**
> EncryptFinalResponse encrypt_final_ex(body)

Conclude multi-part encryption

Conclude a multi-part encryption operation. See `encrypt/init` for details. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.EncryptFinalRequestEx() # EncryptFinalRequestEx | Finish multi-part encryption

try: 
    # Conclude multi-part encryption
    api_response = api_instance.encrypt_final_ex(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->encrypt_final_ex: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**EncryptFinalRequestEx**](EncryptFinalRequestEx.md)| Finish multi-part encryption | 

### Return type

[**EncryptFinalResponse**](EncryptFinalResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **encrypt_init**
> EncryptInitResponse encrypt_init(key_id, body)

Begin multi-part encryption

This API is used when encrypting more data than the client wishes to submit in a single request. It supports only symmetric ciphers and only conventional (not AEAD) modes of operation. To perform multi-part encryption, the client makes one request to the `init` resource, zero or more requests to the `update` resource, followed by one request to the `final` resource. The response to init and update requests includes a `state` field. The `state` is an opaque data blob that must be supplied unmodified by the client with the subsequent request. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
key_id = 'key_id_example' # str | kid of security object
body = sdkms/v1.EncryptInitRequest() # EncryptInitRequest | Multi-part encryption initialization request

try: 
    # Begin multi-part encryption
    api_response = api_instance.encrypt_init(key_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->encrypt_init: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **str**| kid of security object | 
 **body** | [**EncryptInitRequest**](EncryptInitRequest.md)| Multi-part encryption initialization request | 

### Return type

[**EncryptInitResponse**](EncryptInitResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **encrypt_init_ex**
> EncryptInitResponse encrypt_init_ex(body)

Begin multi-part encryption

This API is used when encrypting more data than the client wishes to submit in a single request. It supports only symmetric ciphers and only conventional (not AEAD) modes of operation. To perform multi-part encryption, the client makes one request to the `init` resource, zero or more requests to the `update` resource, followed by one request to the `final` resource. The response to init and update requests includes a `state` field. The `state` is an opaque data blob that must be supplied unmodified by the client with the subsequent request. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.EncryptInitRequestEx() # EncryptInitRequestEx | Multi-part encryption initialization request

try: 
    # Begin multi-part encryption
    api_response = api_instance.encrypt_init_ex(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->encrypt_init_ex: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**EncryptInitRequestEx**](EncryptInitRequestEx.md)| Multi-part encryption initialization request | 

### Return type

[**EncryptInitResponse**](EncryptInitResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **encrypt_update**
> EncryptUpdateResponse encrypt_update(key_id, body)

Continue multi-part encryption

Continue a multi-part encryption operation. See `encrypt/init` for details. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
key_id = 'key_id_example' # str | kid of security object
body = sdkms/v1.EncryptUpdateRequest() # EncryptUpdateRequest | Multi-part encryption

try: 
    # Continue multi-part encryption
    api_response = api_instance.encrypt_update(key_id, body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->encrypt_update: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **key_id** | **str**| kid of security object | 
 **body** | [**EncryptUpdateRequest**](EncryptUpdateRequest.md)| Multi-part encryption | 

### Return type

[**EncryptUpdateResponse**](EncryptUpdateResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **encrypt_update_ex**
> EncryptUpdateResponse encrypt_update_ex(body)

Continue multi-part encryption

Continue a multi-part encryption operation. See `encrypt/init` for details. 

### Example 
```python
from __future__ import print_function
import time
import sdkms/v1
from sdkms/v1.rest import ApiException
from pprint import pprint

# Configure API key authorization: bearerToken
configuration = sdkms/v1.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = sdkms/v1.EncryptionAndDecryptionApi(sdkms/v1.ApiClient(configuration))
body = sdkms/v1.EncryptUpdateRequestEx() # EncryptUpdateRequestEx | Multi-part encryption

try: 
    # Continue multi-part encryption
    api_response = api_instance.encrypt_update_ex(body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling EncryptionAndDecryptionApi->encrypt_update_ex: %s\n" % e)
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**EncryptUpdateRequestEx**](EncryptUpdateRequestEx.md)| Multi-part encryption | 

### Return type

[**EncryptUpdateResponse**](EncryptUpdateResponse.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

